System.register(["./LZMA"], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var LZMA_1;
    var BitTreeDecoder;
    return {
        setters:[
            function (LZMA_1_1) {
                LZMA_1 = LZMA_1_1;
            }],
        execute: function() {
            BitTreeDecoder = (function () {
                function BitTreeDecoder(numBits) {
                    this.numBits = numBits;
                    this.probs = new Uint16Array(1 << this.numBits);
                }
                BitTreeDecoder.prototype.init = function () {
                    LZMA_1.LZMA.INIT_PROBS(this.probs);
                };
                BitTreeDecoder.prototype.decode = function (rc) {
                    var m = 1;
                    for (var i = 0; i < this.numBits; i++)
                        m = (m << 1) + rc.decodeBit(this.probs, m);
                    return m - (1 << this.numBits);
                };
                BitTreeDecoder.prototype.reverseDecode = function (rc) {
                    return LZMA_1.LZMA.BitTreeReverseDecode(this.probs, this.numBits, rc);
                };
                BitTreeDecoder.constructArray = function (numBits, len) {
                    var vec = [];
                    for (var i = 0; i < len; i++) {
                        vec[i] = new BitTreeDecoder(numBits);
                    }
                    return vec;
                };
                return BitTreeDecoder;
            }());
            exports_1("BitTreeDecoder", BitTreeDecoder);
        }
    }
});
//# sourceMappingURL=BitTreeDecoder.js.map