System.register(["./BitTreeDecoder", "./LZMA"], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var BitTreeDecoder_1, LZMA_1;
    var LenDecoder;
    return {
        setters:[
            function (BitTreeDecoder_1_1) {
                BitTreeDecoder_1 = BitTreeDecoder_1_1;
            },
            function (LZMA_1_1) {
                LZMA_1 = LZMA_1_1;
            }],
        execute: function() {
            LenDecoder = (function () {
                function LenDecoder() {
                    this.lowCoder = BitTreeDecoder_1.BitTreeDecoder.constructArray(3, 1 << LZMA_1.LZMA.kNumPosBitsMax);
                    this.midCoder = BitTreeDecoder_1.BitTreeDecoder.constructArray(3, 1 << LZMA_1.LZMA.kNumPosBitsMax);
                    this.highCoder = new BitTreeDecoder_1.BitTreeDecoder(8);
                }
                LenDecoder.prototype.init = function () {
                    this.choice = [LZMA_1.LZMA.PROB_INIT_VAL, LZMA_1.LZMA.PROB_INIT_VAL];
                    this.highCoder.init();
                    for (var i = 0; i < (1 << LZMA_1.LZMA.kNumPosBitsMax); i++) {
                        this.lowCoder[i].init();
                        this.midCoder[i].init();
                    }
                };
                LenDecoder.prototype.decode = function (rc, posState) {
                    if (rc.decodeBit(this.choice, 0) == 0) {
                        return this.lowCoder[posState].decode(rc);
                    }
                    if (rc.decodeBit(this.choice, 1) == 0) {
                        return 8 + this.midCoder[posState].decode(rc);
                    }
                    return 16 + this.highCoder.decode(rc);
                };
                return LenDecoder;
            }());
            exports_1("LenDecoder", LenDecoder);
        }
    }
});
//# sourceMappingURL=LenDecoder.js.map