System.register(["./ByteArray"], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var __extends = (this && this.__extends) || function (d, b) {
        for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
    var ByteArray_1;
    var BitArray;
    return {
        setters:[
            function (ByteArray_1_1) {
                ByteArray_1 = ByteArray_1_1;
            }],
        execute: function() {
            BitArray = (function (_super) {
                __extends(BitArray, _super);
                function BitArray(buffer) {
                    _super.call(this, buffer);
                    this.bitsPending = 0;
                }
                BitArray.prototype.readBits = function (bits, bitBuffer) {
                    if (bitBuffer === void 0) { bitBuffer = 0; }
                    if (bits == 0) {
                        return bitBuffer;
                    }
                    var partial;
                    var bitsConsumed;
                    if (this.bitsPending > 0) {
                        var _byte = this[this.position - 1] & (0xff >> (8 - this.bitsPending));
                        bitsConsumed = Math.min(this.bitsPending, bits);
                        this.bitsPending -= bitsConsumed;
                        partial = _byte >> this.bitsPending;
                    }
                    else {
                        bitsConsumed = Math.min(8, bits);
                        this.bitsPending = 8 - bitsConsumed;
                        partial = this.readUnsignedByte() >> this.bitsPending;
                    }
                    bits -= bitsConsumed;
                    bitBuffer = (bitBuffer << bitsConsumed) | partial;
                    return (bits > 0) ? this.readBits(bits, bitBuffer) : bitBuffer;
                };
                BitArray.prototype.writeBits = function (bits, value) {
                    if (bits == 0) {
                        return;
                    }
                    value &= (0xffffffff >>> (32 - bits));
                    var bitsConsumed;
                    if (this.bitsPending > 0) {
                        if (this.bitsPending > bits) {
                            this[this.position - 1] |= value << (this.bitsPending - bits);
                            bitsConsumed = bits;
                            this.bitsPending -= bits;
                        }
                        else if (this.bitsPending == bits) {
                            this[this.position - 1] |= value;
                            bitsConsumed = bits;
                            this.bitsPending = 0;
                        }
                        else {
                            this[this.position - 1] |= value >> (bits - this.bitsPending);
                            bitsConsumed = this.bitsPending;
                            this.bitsPending = 0;
                        }
                    }
                    else {
                        bitsConsumed = Math.min(8, bits);
                        this.bitsPending = 8 - bitsConsumed;
                        this.writeByte((value >> (bits - bitsConsumed)) << this.bitsPending);
                    }
                    bits -= bitsConsumed;
                    if (bits > 0) {
                        this.writeBits(bits, value);
                    }
                };
                BitArray.prototype.resetBitsPending = function () {
                    this.bitsPending = 0;
                };
                BitArray.calculateMaxBits = function (signed, values) {
                    var b = 0;
                    var vmax = -2147483648;
                    if (!signed) {
                        for (var i = 0; i < values.length; i++) {
                            b |= values[i];
                        }
                    }
                    else {
                        for (var i = 0; i < values.length; i++) {
                            var svalue = values[i];
                            if (svalue >= 0) {
                                b |= svalue;
                            }
                            else {
                                b |= ~svalue << 1;
                            }
                            if (vmax < svalue) {
                                vmax = svalue;
                            }
                        }
                    }
                    var bits = 0;
                    if (b > 0) {
                        bits = b.toString(2).length;
                        if (signed && vmax > 0 && vmax.toString(2).length >= bits) {
                            bits++;
                        }
                    }
                    return bits;
                };
                return BitArray;
            }(ByteArray_1.ByteArray));
            exports_1("BitArray", BitArray);
        }
    }
});
//# sourceMappingURL=BitArray.js.map