System.register(["./ByteArray", "./CompressionAlgorithm", "./LZMAHelper"], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var __extends = (this && this.__extends) || function (d, b) {
        for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
    var ByteArray_1, CompressionAlgorithm_1, LZMAHelper_1;
    var DataArray;
    return {
        setters:[
            function (ByteArray_1_1) {
                ByteArray_1 = ByteArray_1_1;
            },
            function (CompressionAlgorithm_1_1) {
                CompressionAlgorithm_1 = CompressionAlgorithm_1_1;
            },
            function (LZMAHelper_1_1) {
                LZMAHelper_1 = LZMAHelper_1_1;
            }],
        execute: function() {
            DataArray = (function (_super) {
                __extends(DataArray, _super);
                function DataArray(buffer, offset, length) {
                    if (offset === void 0) { offset = 0; }
                    if (length === void 0) { length = 0; }
                    _super.call(this, buffer, offset, length);
                }
                DataArray.prototype.compress = function (algorithm) {
                    if (algorithm === void 0) { algorithm = CompressionAlgorithm_1.CompressionAlgorithm.LZMA; }
                    if (algorithm == CompressionAlgorithm_1.CompressionAlgorithm.LZMA) {
                        throw "Compression error! " + algorithm + " not implemented";
                    }
                    else {
                        throw "Compression error! " + algorithm + " not implemented";
                    }
                };
                DataArray.prototype.decompressBuffer = function (algorithm) {
                    if (algorithm === void 0) { algorithm = CompressionAlgorithm_1.CompressionAlgorithm.LZMA; }
                    if (algorithm == CompressionAlgorithm_1.CompressionAlgorithm.LZMA) {
                        try {
                            this.buffer = LZMAHelper_1.LZMAHelper.decodeBuffer(this.buffer);
                        }
                        catch (e) {
                            throw "Uncompression error! " + algorithm + " not implemented";
                        }
                    }
                    else if (algorithm == CompressionAlgorithm_1.CompressionAlgorithm.ZLIB) {
                    }
                    else {
                        throw "Uncompression error! " + algorithm + " not implemented";
                    }
                };
                DataArray.prototype.decompress = function (algorithm) {
                    if (algorithm === void 0) { algorithm = CompressionAlgorithm_1.CompressionAlgorithm.LZMA; }
                    if (algorithm == CompressionAlgorithm_1.CompressionAlgorithm.LZMA) {
                        try {
                            this.array = LZMAHelper_1.LZMAHelper.decode(this.array);
                        }
                        catch (e) {
                            throw "Uncompression error! " + algorithm + " not implemented";
                        }
                    }
                    else if (algorithm == CompressionAlgorithm_1.CompressionAlgorithm.ZLIB) {
                    }
                    else {
                        throw "Uncompression error! " + algorithm + " not implemented";
                    }
                };
                DataArray.prototype.compressAsync = function (algorithm, callback) {
                    if (algorithm == CompressionAlgorithm_1.CompressionAlgorithm.LZMA) {
                        throw "Compression error! " + algorithm + " not implemented";
                    }
                    else {
                        throw "Compression error! " + algorithm + " not implemented";
                    }
                };
                DataArray.prototype.decompressAsync = function (algorithm, callback) {
                    if (algorithm === void 0) { algorithm = CompressionAlgorithm_1.CompressionAlgorithm.LZMA; }
                    if (callback === void 0) { callback = null; }
                    if (algorithm == CompressionAlgorithm_1.CompressionAlgorithm.LZMA) {
                        LZMAHelper_1.LZMAHelper.decodeAsync(this.buffer, function (_data) {
                            this.buffer = _data;
                        });
                    }
                    else {
                        throw "Uncompression error! " + algorithm + " not implemented";
                    }
                };
                DataArray.prototype.deflate = function () {
                };
                DataArray.prototype.inflate = function () {
                };
                DataArray.prototype.readBytesAsByteArray = function (_bytes, offset, length, createNewBuffer) {
                    if (_bytes === void 0) { _bytes = null; }
                    if (offset === void 0) { offset = 0; }
                    if (length === void 0) { length = 0; }
                    if (createNewBuffer === void 0) { createNewBuffer = false; }
                    console.warn("[DEPRECATED] readBytesAsByteArray is deprecated use readBytesAsDataArray instead");
                    return this.readBytesAsDataArray(_bytes, offset, length, createNewBuffer);
                };
                DataArray.prototype.readBytesAsDataArray = function (_bytes, offset, length, createNewBuffer) {
                    if (_bytes === void 0) { _bytes = null; }
                    if (offset === void 0) { offset = 0; }
                    if (length === void 0) { length = 0; }
                    if (createNewBuffer === void 0) { createNewBuffer = false; }
                    if (length == 0) {
                        length = this.bytesAvailable;
                    }
                    else if (!this.validate(length))
                        return null;
                    if (createNewBuffer) {
                        _bytes = _bytes == null ? new DataArray(new ArrayBuffer(length)) : _bytes;
                        for (var i = 0; i < length; i++) {
                            _bytes.data.setUint8(i + offset, this.data.getUint8(this.position++));
                        }
                    }
                    else {
                        _bytes = _bytes == null ? new DataArray(null) : _bytes;
                        _bytes.dataView = new DataView(this.data.buffer, this.bufferOffset + this.position, length);
                        this.position += length;
                    }
                    return _bytes;
                };
                DataArray.prototype.readObject = function () {
                    return null;
                };
                DataArray.prototype.writeObject = function (value) {
                };
                DataArray.BIG_ENDIAN = "bigEndian";
                DataArray.LITTLE_ENDIAN = "littleEndian";
                return DataArray;
            }(ByteArray_1.ByteArray));
            exports_1("DataArray", DataArray);
        }
    }
});
//# sourceMappingURL=DataArray.js.map