System.register([], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var HalfPrecisionWriter;
    return {
        setters:[],
        execute: function() {
            HalfPrecisionWriter = (function () {
                function HalfPrecisionWriter() {
                }
                HalfPrecisionWriter.write = function (value, data) {
                    data.resetBitsPending();
                    var dword;
                    var sign;
                    var exponent;
                    var significand;
                    var halfSignificand;
                    var signedExponent;
                    var result;
                    var p;
                    p = data.position;
                    data.writeDouble(value);
                    data.position -= 4;
                    dword = data.readUnsignedInt();
                    data.position = p;
                    if ((dword & 0x7FFFFFFF) == 0) {
                        result = dword >> 16;
                    }
                    else {
                        sign = dword & 0x80000000;
                        exponent = dword & 0x7FF00000;
                        significand = dword & 0x000FFFFF;
                        if (exponent == 0) {
                            result = sign >> 16;
                        }
                        else if (exponent == 0x7FF00000) {
                            if (significand == 0) {
                                result = ((sign >> 16) | 0x7C00);
                            }
                            else {
                                result = 0xFE00;
                            }
                        }
                        else {
                            sign = sign >> 16;
                            signedExponent = (exponent >> 20) - 1023 + 15;
                            if (signedExponent >= 0x1F) {
                                result = ((significand >> 16) | 0x7C00);
                            }
                            else if (signedExponent <= 0) {
                                if ((10 - signedExponent) > 21) {
                                    halfSignificand = 0;
                                }
                                else {
                                    significand |= 0x00100000;
                                    halfSignificand = (significand >> (11 - signedExponent));
                                    if ((significand >> (10 - signedExponent)) & 0x00000001) {
                                        halfSignificand += 1;
                                    }
                                }
                                result = (sign | halfSignificand);
                            }
                            else {
                                exponent = signedExponent << 10;
                                halfSignificand = significand >> 10;
                                if (significand & 0x00000200) {
                                    result = (sign | exponent | halfSignificand) + 1;
                                }
                                else {
                                    result = (sign | exponent | halfSignificand);
                                }
                            }
                        }
                    }
                    data.writeShort(result);
                    data.length = p + 2;
                };
                return HalfPrecisionWriter;
            }());
            exports_1("HalfPrecisionWriter", HalfPrecisionWriter);
        }
    }
});
//# sourceMappingURL=HalfPrecisionWriter.js.map