System.register(["../lzma/LZMA"], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var LZMA_1;
    var LZMAHelper;
    return {
        setters:[
            function (LZMA_1_1) {
                LZMA_1 = LZMA_1_1;
            }],
        execute: function() {
            LZMAHelper = (function () {
                function LZMAHelper() {
                }
                LZMAHelper.init = function (workerScript) {
                    if (workerScript) {
                        LZMAHelper.workerScript = workerScript;
                    }
                    if (LZMAHelper.decoderAsync) {
                        LZMAHelper.decoderAsync.terminate();
                        LZMAHelper.decoderAsync = null;
                    }
                    if (LZMAHelper.enableAsync) {
                        LZMAHelper.decoderAsync = new Worker(LZMAHelper.workerScript);
                        LZMAHelper.decoderAsync.onmessage = function (e) {
                            var receivedData = e.data;
                            if (receivedData.command === LZMAHelper.ENCODE) {
                            }
                            else if (receivedData.command === LZMAHelper.DECODE) {
                                LZMAHelper.callback(receivedData.result);
                                LZMAHelper.callback = null;
                            }
                        };
                    }
                };
                LZMAHelper.encode = function (data) {
                    throw "LZMA encoder not implemented!";
                };
                LZMAHelper.decodeBuffer = function (data) {
                    return LZMAHelper.decoder.decode(new Uint8Array(data)).buffer;
                };
                LZMAHelper.decode = function (data) {
                    return LZMAHelper.decoder.decode(data);
                };
                LZMAHelper.encodeAsync = function (data, _callback) {
                    if (LZMAHelper.enableAsync) {
                        throw "LZMA encoder not implemented!";
                    }
                    else {
                        console.log('Error! Asynchronous encoding is disabled');
                    }
                };
                LZMAHelper.decodeAsync = function (data, _callback) {
                    if (LZMAHelper.enableAsync) {
                        if (LZMAHelper.callback == null) {
                            LZMAHelper.callback = _callback;
                            LZMAHelper.decoderAsync.postMessage({ command: LZMAHelper.DECODE, data: data }, [data]);
                        }
                        else {
                            console.log('Warning! Another LZMA decoding is running...');
                        }
                    }
                    else {
                        console.log('Error! Asynchronous decoding is disabled');
                    }
                };
                LZMAHelper.decoder = new LZMA_1.LZMA();
                LZMAHelper.enableAsync = true;
                LZMAHelper.ENCODE = 1;
                LZMAHelper.DECODE = 2;
                LZMAHelper.workerScript = "../modules/xdata/workers/lzma-worker-bootstrap.js";
                return LZMAHelper;
            }());
            exports_1("LZMAHelper", LZMAHelper);
        }
    }
});
//# sourceMappingURL=LZMAHelper.js.map