System.register([], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var Adler32;
    return {
        setters:[],
        execute: function() {
            Adler32 = (function () {
                function Adler32() {
                }
                Adler32.calc = function (array) {
                    if (typeof (array) === 'string') {
                        array = Adler32.encodeString(array);
                    }
                    return Adler32.update(1, array);
                };
                Adler32.update = function (adler, array) {
                    var s1 = adler & 0xffff;
                    var s2 = (adler >>> 16) & 0xffff;
                    var len = array.length;
                    var tlen;
                    var i = 0;
                    while (len > 0) {
                        tlen = len > Adler32.OptimizationParameter ?
                            Adler32.OptimizationParameter : len;
                        len -= tlen;
                        do {
                            s1 += array[i++];
                            s2 += s1;
                        } while (--tlen);
                        s1 %= 65521;
                        s2 %= 65521;
                    }
                    return ((s2 << 16) | s1) >>> 0;
                };
                Adler32.encodeString = function (str) {
                    if (!Adler32.encoder) {
                        if (window["TextEncoder"]) {
                            Adler32.encoder = new window["TextEncoder"]();
                        }
                        else {
                            Adler32.encoder = {
                                encode: function (str) {
                                    var tmp = str.split('');
                                    var data = new Uint8Array(tmp.length);
                                    var i;
                                    var il;
                                    for (i = 0, il = tmp.length; i < il; i++) {
                                        data[i] = (tmp[i].charCodeAt(0) & 0xff) >>> 0;
                                    }
                                    return data;
                                }
                            };
                        }
                    }
                    return Adler32.encoder.encode(str);
                };
                Adler32.OptimizationParameter = 1024;
                return Adler32;
            }());
            exports_1("Adler32", Adler32);
        }
    }
});
//# sourceMappingURL=Adler32.js.map