System.register([], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var Huffman;
    return {
        setters:[],
        execute: function() {
            Huffman = (function () {
                function Huffman() {
                }
                Huffman.buildHuffmanTable = function (lengths) {
                    var listSize = lengths.length;
                    var maxCodeLength = 0;
                    var minCodeLength = Number.POSITIVE_INFINITY;
                    var size;
                    var table;
                    var bitLength;
                    var code;
                    var skip;
                    var reversed;
                    var rtemp;
                    var i;
                    var il;
                    var j;
                    var value;
                    for (i = 0, il = listSize; i < il; ++i) {
                        if (lengths[i] > maxCodeLength) {
                            maxCodeLength = lengths[i];
                        }
                        if (lengths[i] < minCodeLength) {
                            minCodeLength = lengths[i];
                        }
                    }
                    size = 1 << maxCodeLength;
                    table = new Uint32Array(size);
                    for (bitLength = 1, code = 0, skip = 2; bitLength <= maxCodeLength;) {
                        for (i = 0; i < listSize; ++i) {
                            if (lengths[i] === bitLength) {
                                for (reversed = 0, rtemp = code, j = 0; j < bitLength; ++j) {
                                    reversed = (reversed << 1) | (rtemp & 1);
                                    rtemp >>= 1;
                                }
                                value = (bitLength << 16) | i;
                                for (j = reversed; j < size; j += skip) {
                                    table[j] = value;
                                }
                                ++code;
                            }
                        }
                        ++bitLength;
                        code <<= 1;
                        skip <<= 1;
                    }
                    return [table, maxCodeLength, minCodeLength];
                };
                return Huffman;
            }());
            exports_1("Huffman", Huffman);
        }
    }
});
//# sourceMappingURL=Huffman.js.map