System.register(["./RawInflate", "./CompressionMethod", "./Adler32"], function(exports_1, context_1) {
    "use strict";
    var __moduleName = context_1 && context_1.id;
    var RawInflate_1, CompressionMethod_1, Adler32_1;
    var Inflate;
    return {
        setters:[
            function (RawInflate_1_1) {
                RawInflate_1 = RawInflate_1_1;
            },
            function (CompressionMethod_1_1) {
                CompressionMethod_1 = CompressionMethod_1_1;
            },
            function (Adler32_1_1) {
                Adler32_1 = Adler32_1_1;
            }],
        execute: function() {
            Inflate = (function () {
                function Inflate(input, opt_params) {
                    if (opt_params === void 0) { opt_params = null; }
                    this.ip = 0;
                    this.input = input;
                    if (opt_params || !(opt_params = {})) {
                        if (opt_params['index']) {
                            this.ip = opt_params['index'];
                        }
                        if (opt_params['verify']) {
                            this.verify = opt_params['verify'];
                        }
                    }
                    this.cmf = input[this.ip++];
                    this.flg = input[this.ip++];
                    switch (this.cmf & 0x0f) {
                        case CompressionMethod_1.CompressionMethod.ZLIB.DEFLATE:
                            this.method = CompressionMethod_1.CompressionMethod.ZLIB.DEFLATE;
                            break;
                        default:
                            throw new Error('unsupported compression method');
                    }
                    if (((this.cmf << 8) + this.flg) % 31 !== 0) {
                        throw new Error('invalid fcheck flag:' + ((this.cmf << 8) + this.flg) % 31);
                    }
                    if (this.flg & 0x20) {
                        throw new Error('fdict flag is not supported');
                    }
                    this.rawinflate = new RawInflate_1.RawInflate(input, {
                        'index': this.ip,
                        'bufferSize': opt_params['bufferSize'],
                        'bufferType': opt_params['bufferType'],
                        'resize': opt_params['resize']
                    });
                }
                Inflate.prototype.decompress = function () {
                    var input = this.input;
                    var buffer;
                    var adler32;
                    buffer = this.rawinflate.decompress();
                    this.ip = this.rawinflate.ip;
                    if (this.verify) {
                        adler32 = (input[this.ip++] << 24 | input[this.ip++] << 16 |
                            input[this.ip++] << 8 | input[this.ip++]) >>> 0;
                        if (adler32 !== Adler32_1.Adler32.calc(buffer)) {
                            throw new Error('invalid adler-32 checksum');
                        }
                    }
                    return buffer;
                };
                Inflate.BufferType = RawInflate_1.RawInflate.BufferType;
                return Inflate;
            }());
            exports_1("Inflate", Inflate);
        }
    }
});
//# sourceMappingURL=Inflate.js.map